Attribute VB_Name = "modPlugins071"
' copyright 2004-2010 Erik Siers
' For usage & license, see the file "EEShell2.txt"

' the plugin system for EEShell2
' required by:
'   [plugins]

' 20080929 EES:
'   I wonder if I could have done this any worse.
'   I create *at least* two instances of each object. One gets unloaded after
'   EEShell2 checks to see if it exists; that is that instance's entire purpose.
'   Much better to create, test, then add to array.
'   ...should consider making this a Class.

Option Explicit

' removed 20090314 (no longer in DLL)
' Public Declare Function pReadINI Lib "EEShell2.dll" (plugin As String, key As String, info As String) As Long
' Public Declare Function pWriteINI Lib "EEShell2.dll" (plugin As String, key As String, info As String) As Long

Public Type plugin
    pObj As Object
    pName As String
    pFile As String
    pLoaded As Boolean  ' added 20080929 -- use this instead of isValidPlugin
End Type

' pCount = 0 -> no plugins -- first plugin is #1, plugin #0 is placeholder
Public pCount As Long
Public Plugins() As plugin


' removed 20090314 -- no longer needed
'Public Function listPlugins() As String()
'    ' returns a string array of the names of all valid plugins
'
'    Dim n As Long
'    ReDim outP(pCount) As String
'
'    For n = 1 To pCount
'        outP(n) = Plugins(n).pName
'    Next
'    listPlugins = outP
'End Function


Public Sub findPlugins()
    ' looks in plugins directory and finds all .dll files
    ' those that are registered get mapped into Plugins() array
    ' those that aren't registered *should* be ignored, but for some reason they
    ' sometimes *aren't* ignored

    ' can't do this more than once per instance
    Dim z As Long
    If pCount > 0 Then
        z = appLog("Error: tried to load plugins with pCount > 0", "findPlugins")
        Exit Sub
    End If

    Dim x As String, y As String, curD As String, curDr As String * 1

    curD = CurDir
    curDr = Left(curD, 1)
    ChDrive Left(App.Path, 1)
    ChDir App.Path & "\Plugins"
    x = Dir("*.dll")
    Do While x <> ""
        y = Left(x, InStr(x, ".") - 1)
        ' If isValidPlugin(y) Then  ' removed 20080929
            pCount = pCount + 1
            ReDim Preserve Plugins(pCount)
            Plugins(pCount).pFile = App.Path & "\Plugins\" & x
            Plugins(pCount).pName = y
            ' here we need to load the COM object "Plugin" stored in the current DLL
            '*****TO DO*****
            ' instead of COM objects, make it load as normal DLL
            ' Plugins(pCount).pObj
            z = appLog("Found plugin: " & y & " in " & Plugins(pCount).pFile, "findPlugins")
        ' End If                    ' removed 20080929
        x = Dir
    Loop
    loadPlugins
    ChDrive curDr
    ChDir curD
End Sub


Public Sub loadPlugins()
    ' loads all plugins into memory by creating an object from each DLL
    ' if we get here, plugins should already have been checked for being registered

    Dim f As String, n As Long
    For n = 1 To pCount
        f = Plugins(n).pName & ".Plugin"
        Set Plugins(n).pObj = CreateObject(f)
    Next
End Sub


Public Sub unloadPlugins()
    ' (hopefully) unloads all plugins by erasing the object created from each DLL

    Dim n As Long
    For n = pCount To 1 Step -1
        Set Plugins(n).pObj = Nothing
    Next
    pCount = 0
End Sub

' removed 20080929 -- not needed
'Private Function isValidPlugin(DLL As String) As Boolean
'    ' determines if plugin has been registered properly
'
'    On Error Resume Next
'    Dim x As Object, n As String
'
'    n = DLL & ".Plugin"
'    Set x = CreateObject(n)
'    isValidPlugin = Not (x Is Nothing)
'    Set x = Nothing
'End Function
