' The main file for EEShell2.dll.
' requires:
'   Win32API.bi
' required by:
'   Run.bi
'   Shell.bi
'   Shutdown.bi
'   Startup.bi

' Copyright 2004-2010 Erik Siers
' EEShell2 is a complete, functional replacement shell for Windows.
' For details, usage & license, see the file "EEShell2.txt"

'''''to do: debug setSystemShell* funcs in shell.bi
'''''update 8/16/2008: looks like the Shell stuff is *finally* working
'''''                  not thoroughly tested, though


$COMPILE DLL
$COMPILER PBWIN
$DEBUG ERROR OFF
$DIM ALL
$OPTION VERSION4
$RESOURCE "EEShell2.pbr"    ' contains version info and icon
$TOOLS OFF

%dBug = 0
%usePNG = 0 'also controls PCX - once it's working for sure in the main app, remove all references to this

#INCLUDE "Win32API.bi"

GLOBAL dllPath AS STRING


FUNCTION WinVer ALIAS "WinVer" () EXPORT AS SINGLE
    ' returns the Windows version, i.e. 3.11
    ' included for compatibility w/Win16 version (which uses GetVersion, not GetVersionEx)
    DIM retval AS STRING

    LOCAL myOS AS OSVERSIONINFO
    myOS.dwOSVersionInfoSize = LEN(myOS)
    GetVersionEx myOS
    retval = TRIM$(STR$(myOS.dwMajorVersion)) & "." & TRIM$(STR$(myOS.dwMinorVersion))
    WinVer = VAL(retval)
END FUNCTION


FUNCTION IsWinNT ALIAS "IsWinNT" () EXPORT AS LONG
    ' Detect if the program is running under Windows NT
    ' found somewhere on the www
    ' calls:
    '   GetVersionEx    (Win32API.bi->kernel32)
    ' called by:
    '   getSystemShell  (Shell.bi)
    '   setSystemShell  (Shell.bi)
    '   quitWindows     (Shutdown.bi)

    LOCAL myOS AS OSVERSIONINFO

    myOS.dwOSVersionInfoSize = LEN(myOS)
    GetVersionEx myOS
    IsWinNT = ISFALSE (myOS.dwPlatformId <> %VER_PLATFORM_WIN32_NT)
END FUNCTION


SUB appLog ALIAS "appLog"(logEvent AS STRING) EXPORT
    ' logs anything sent its way
    ' args:
    '   logEvent    what to log
    ' called by:
    '   GetKeyValue         (Shell.bi)
    '   quitWindows         (Shutdown.bi)
    '   Run                 (Run.bi)  (if I can ever figure out error handling)
    '   runStartup          (Startup.bi)
    '   SetKeyValue         (Shell.bi)
    '   SetSystemShellNT    (Shell.bi)
    '   EEShell2.exe->frmBG.cmdExit_Click
    '   EEShell2.exe->frmBG.cmdLogoff_Click
    '   EEShell2.exe->frmBG.cmdRestart_Click
    '   EEShell2.exe->frmBG.cmdShutdown_Click
    '   EEShell2.exe->frmBG.doImage
    '   EEShell2.exe->frmBG.Form_Load
    '   EEShell2.exe->frmBG.mnuPopupButtonDefaults_Click
    '   EEShell2.exe->frmBG.resizeForm
    '   EEShell2.exe->frmOpts.cmdOK_Click
    '   EEShell2.exe->frmOpts.Form_Load
    '   EEShell2.exe->modMain.Main

    ON ERROR RESUME NEXT
    DIM n AS LONG

    n = FREEFILE
    OPEN dllPath & "EEShell2.log" FOR APPEND AS n
        PRINT #n, DATE$ & $SPC & TIME$ & " - " & logEvent
    CLOSE
END SUB


SUB GetDesktopInfo ALIAS "GetDesktopInfo" (BYREF loc_X AS LONG, BYREF loc_Y AS LONG, BYREF size_Width AS LONG, _
        BYREF size_Height AS LONG, BYREF client_Width AS LONG, BYREF client_Height AS LONG) EXPORT
    ' gets desktop size info
    ' args:
    '   loc_X, loc_Y                top left corner of desktop
    '   size_Width, size_Height     size of desktop
    '   client_Width, clientHeight  size of client area
    ' called by:
    '   EEShell2.exe->frmBG.resizeForm

    DESKTOP GET LOC TO loc_X, loc_Y
    DESKTOP GET SIZE TO size_Width, size_Height
    DESKTOP GET CLIENT TO client_Width, client_Height
END SUB


SUB setPath ALIAS "setPath" () EXPORT
    ' sets dllPath to EEShell2.exe->App.Path (oh, the irony)
    ' args:
    '   path    App.Path from EEShell2.exe
    ' called by:
    '   EEShell2.exe->modMain.Main

    dllPath = IIF$ ("\" = RIGHT$(EXE.PATH$, 1), EXE.PATH$, EXE.PATH$ & "\")
END SUB


#INCLUDE "ImageLister.bi"
#INCLUDE "Run.bi"
#INCLUDE "Shell.bi"
#INCLUDE "Shutdown.bi"
#INCLUDE "Startup.bi"


FUNCTION LIBMAIN(BYVAL hInstance AS DWORD, BYVAL lReason AS LONG, BYVAL lReserved AS LONG) AS LONG
    SELECT CASE lReason
        CASE %DLL_PROCESS_ATTACH
            setInitialValues
            setPath
            FUNCTION = 1
        CASE %DLL_PROCESS_DETACH
            closeImages
    END SELECT
END FUNCTION
