' The shutdown module for EEShell2.dll.
' requires:
'   EEShell2.bas
'   Win32API.bi

' Found somewhere on the www (can't remember where) so not copyrighted by me;
' all I did was port it from VB to PB.


MACRO EnableShutDown()
    ' Set the shut down privilege for the current application
    ' calls:
    '   AdjustTokenPrivileges   (Win32API.bi->advapi32)
    '   GetCurrentProcess       (Win32API.bi->kernel32)
    '   LookupPrivilegeValue    (Win32API.bi->advapi32)
    '   OpenProcessToken        (Win32API.bi->advapi32)
    ' called by:
    '   quitWindows

    MACROTEMP hProc, hToken, mLUID, mPriv, mNewPriv

    DIM hProc AS LONG, hToken AS LONG, mLUID AS LUID
    DIM mPriv AS TOKEN_PRIVILEGES, mNewPriv AS TOKEN_PRIVILEGES

    hProc = GetCurrentProcess()
    OpenProcessToken hProc, %TOKEN_ADJUST_PRIVILEGES + %TOKEN_QUERY, hToken
    LookupPrivilegeValue "", "SeShutdownPrivilege", mLUID
    mPriv.PrivilegeCount = 1
    mPriv.Privileges(0).Attributes = %SE_PRIVILEGE_ENABLED
    mPriv.Privileges(0).pLuid = mLUID

    ' enable shutdown privilege for the current application
    AdjustTokenPrivileges hToken, 0, mPriv, 4 + (12 * mPriv.PrivilegeCount), mNewPriv, 4 + (12 * mNewPriv.PrivilegeCount)
END MACRO


FUNCTION quitWindows ALIAS "quitWindows" (which AS LONG) EXPORT AS LONG
    ' exit windows (duh)
    ' args:
    '   which   what kind of shutdown to do (values defined in EEShell2.exe->modAPI as EWX_*)
    ' calls:
    '   appLog          (EEShell2.bas)
    '   EnableShutDown
    '   ExitWindowsEx   (Win32API.bi->user32)
    '   IsWinNT         (EEShell2.bas)
    '   FormatMessage   (Win32API.bi->kernel32)
    ' called by:
    '   EEShell2.exe->frmBG.cmdLogoff_Click
    '   EEShell2.exe->frmBG.cmdRestart_Click
    '   EEShell2.exe->frmBG.cmdShutdown_Click

    DIM n AS LONG

#IF %DEF (%dBug)
    appLog "quitWindows code " & STR$(which)
#ENDIF
    IF IsWinNT THEN EnableShutDown
    n = ExitWindowsEx(which, &HFFFF) '((which Or EWX_FORCE), &HFFFF)
    IF n THEN
        DIM x AS ASCIIZ * 256
        n = 0
        FormatMessage %FORMAT_MESSAGE_FROM_SYSTEM, n, ERRAPI, 0, x, 255, n
#IF %DEF (%dBug)
        appLog "-> ExitWindowsEx: " & x
#ENDIF
        FUNCTION = 0
    ELSE
        FUNCTION = -1
    END IF
END FUNCTION
