' The startup module for EEShell2.dll.
' requires:
'   EEShell2.bas
'   Run.bi

' Copyright 2004-2010 Erik Siers
' EEShell2 is a complete, functional replacement shell for Windows.
' For details, usage & license, see the file "EEShell2.txt"


SUB runStartup ALIAS "runStartup" (cmd AS STRING, startup AS LONG) EXPORT
    ' opens all .lnk and .pif files in %EEShell2%\Startup directory
    ' (skipped if -nostartup)
    ' args:
    '   cmd     command$ from VB
    ' calls:
    '   appLog  (EEShell.bas)
    '   Run     (Run.bi)
    ' called by:
    '   EEShell2.exe->modMain.Main

    ON ERROR GOTO ohCrapStartup
    DIM x AS STRING
    x = LCASE$(TRIM$(cmd))
    IF INSTR(x, "nostartup") > 0 THEN EXIT SUB

    DIM c AS STRING, n AS LONG, m AS LONG, a1 AS LONG, a2 AS LONG, found AS LONG
    REDIM runlist(0) AS ASCIIZ * %MAX_PATH

    n = -1
    x = DIR$(dllPath & "\Startup", %FILE_ATTRIBUTE_DIRECTORY)
    IF LEN(x) THEN
        x = ""
        c = CURDIR$
        CHDIR dllPath & "\Startup"
#IF %DEF (%dBug)
        appLog "Executing startup"
#ENDIF
        x = DIR$("*.lnk")
        IF LEN(x) THEN
            found = 1
            DO
                IF LCASE$(LEFT$(x, 8)) <> "disabled" THEN
                    n = n + 1
                    REDIM PRESERVE runlist(n)
                    FOR m = n - 1 TO 0 STEP -1
                        IF x < runlist(m) THEN
                            runlist(m + 1) = runlist(m)
                        ELSE
                            runlist(m + 1) = x
                            GOTO skipper1
                        END IF
                    NEXT
                    runlist(0) = x
                END IF
skipper1:
                x = DIR$
            LOOP WHILE LEN(x)
        END IF
        x = DIR$("*.pif")
        IF LEN(x) THEN
            found = 1
            DO
                IF LCASE$(LEFT$(x, 8)) <> "disabled" THEN
                    n = n + 1
                    REDIM PRESERVE runlist(n)
                    FOR m = n - 1 TO 0 STEP -1
                        IF x < runlist(m) THEN
                            runlist(m + 1) = runlist(m)
                        ELSE
                            runlist(m + 1) = x
                            GOTO skipper2
                        END IF
                    NEXT
                    runlist(0) = x
                END IF
skipper2:
                x = DIR$
            LOOP WHILE LEN(x)
        END IF
        FOR m = 0 TO UBOUND(runlist)
            Run runlist(m), "", ""
            SLEEP 0
        NEXT
        CHDIR c
    END IF

    IF ISTRUE(startup) THEN
        DIM runStartMenu AS ASCIIZ * %MAX_PATH
        n = SHGetSpecialFolderPath(0, runStartMenu, %CSIDL_STARTUP, 0)
        IF LEN(runStartMenu) THEN   ' and if not, then wtf?
            x = CURDIR$
            CHDIR runStartMenu
            runStartMenu = DIR$("*.*")
            DO WHILE runStartMenu <> ""
                IF UCASE$(RIGHT$(runStartMenu, 4)) <> ".INI" THEN
                    Run runStartMenu, "", ""
                    runStartMenu = DIR$
                END IF
            LOOP
        END IF

        n = SHGetSpecialFolderPath(0, runStartMenu, %CSIDL_COMMON_STARTUP, 0)
        IF LEN(runStartMenu) THEN   ' and if not, then wtf?
            x = CURDIR$
            CHDIR runStartMenu
            runStartMenu = DIR$("*.*")
            DO WHILE runStartMenu <> ""
                IF UCASE$(RIGHT$(runStartMenu, 4)) <> ".INI" THEN
                    Run runStartMenu, "", ""
                    runStartMenu = DIR$
                END IF
            LOOP
        END IF
    END IF

    EXIT SUB

ohCrapStartup:
    n = ERRCLEAR
    x = "Error " & STR$(n) & " in runStartup: " & ERROR$(n)
    appLog x
END SUB
