Attribute VB_Name = "modAPI"
' Copyright 2004-2010 Erik Siers
' Provided under terms of the GNU GPL, version 2 or (at your option)
' any later version.
' See the file COPYING.TXT for details.

' API module for EEShell2
' required by:
'   frmAbout
'   frmBG
'   frmOpts
'   modBFF
'   modINI
'   modMain


Public Const FILE_ATTRIBUTE_DIRECTORY = &H10

Public Const BIF_RETURNONLYFSDIRS = &H1
Public Const BIF_DONTGOBELOWDOMAIN = &H2
Public Const BIF_STATUSTEXT = &H4
Public Const BIF_RETURNFSANCESTORS = &H8
Public Const BIF_EDITBOX = &H10
Public Const BIF_VALIDATE = &H20
Public Const BIF_BROWSEFORCOMPUTER = &H1000
Public Const BIF_BROWSEFORPRINTER = &H2000
Public Const BIF_BROWSEINCLUDEFILES = &H4000

#If noDLL Then
    Public Const CSIDL_STARTUP = 7
#End If

Public Const EWX_LOGOFF = &H0
Public Const EWX_SHUTDOWN = &H1
Public Const EWX_REBOOT = &H2
Public Const EWX_FORCE = &H4
Public Const EWX_POWEROFF = &H8
Public Const EWX_FORCEIFHUNG = &H10

Public Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000

Public Const MAX_PATH = 260

Public Type T_BROWSEINFO
    hWndOwner      As Long
    pIDLRoot       As Long
    pszDisplayName As Long
    lpszTitle      As Long
    ulFlags        As Long
    lpfnCallback   As Long
    lParam         As Long
    iImage         As Long
End Type


' EEShell2.dll
#If Not noDLL Then
    Public Declare Sub appLog Lib "EEShell2.dll" (logEvent As String)
    Public Declare Sub GetDesktopInfo Lib "EEShell2.dll" (ByRef loc_X As Long, ByRef loc_Y As Long, _
            ByRef size_Width As Long, ByRef size_Height As Long, ByRef client_Width As Long, _
            ByRef client_Height As Long)
    Public Declare Function IsWinNT Lib "EEShell2.dll" () As Long
    Public Declare Function quitWindows Lib "EEShell2.dll" (which As Long) As Long
    Public Declare Sub Run Lib "EEShell2.dll" (ByVal runItem As String, ByVal cmdLine As String, _
            ByVal defPath As String)
    Public Declare Sub runStartup Lib "EEShell2.dll" (cmd As String, startup As Long)
    Public Declare Sub setPath Lib "EEShell2.dll" ()
    Public Declare Function WinVer Lib "EEShell2.dll" () As Single
    ' image functions
    Public Declare Function nextPic Lib "EEShell2.dll" (Path As String) As String
    Public Declare Function prevPic Lib "EEShell2.dll" (Path As String) As String
    Public Declare Function randPic Lib "EEShell2.dll" (Path As String) As String
    ' ini functions
    Public Declare Function getINIvalue Lib "EEShell2.dll" (ByVal file As String, ByVal section As String, _
            ByVal key As String, ByRef Value As String) As Long
    Public Declare Function writeINIvalue Lib "EEShell2.dll" (ByVal file As String, ByVal section As String, _
            ByVal key As String, ByVal Value As String) As Boolean
    ' shell functions mostly untested outside of WinXP but *should* work
    Public Declare Function setSystemShell Lib "EEShell2.dll" (ByVal appPath As String) As Boolean
'*****unused*****
'    Public Declare Function getSystemShell Lib "EEShell2.dll" () As String
'    Public Declare Function makeImgList Lib "EEShell2.dll" (Path As String) As Long
'    Public Declare Function resEnv Lib "EEShell2.dll" (pPath As String) As String
'    ' this one has been commented out of the DLL source
'    ' if you need it here, you also have to uncomment there and recompile the DLL
'    Public Declare Function getCurrentPic Lib "EEShell2.dll" () As String
#End If         ' noDLL

' kernel/kernel32
#If noDLL Then
    Public Declare Function GetVersion Lib "kernel" () As Long
#End If
Public Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, _
        lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, _
        ByVal nSize As Long, Arguments As Long) As Long
Public Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, _
        ByVal lpString2 As String) As Long

' shell/shell32
Public Declare Function ShellExecute Lib "shell32" Alias "ShellExecuteA" (ByVal hWnd As Long, _
        ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, _
        ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function SHBrowseForFolder Lib "shell32" (lpBI As T_BROWSEINFO) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Public Declare Function SHRunDialog Lib "shell32" Alias "#61" (ByVal hOwner As Long, ByVal Unknown1 As Long, _
        ByVal Unknown2 As Long, ByVal szTitle As String, ByVal szPrompt As String, ByVal uFlags As Long) As Long

' user/user32
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, _
        ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetActiveWindow Lib "user32" () As Long
