Attribute VB_Name = "modMain"
' Copyright 2004-2010 Erik Siers
' Provided under terms of the GNU GPL; see the file COPYING.TXT for details.

' main module for EEShell2
' requires:
'   modAPI
'   modINI
'   if noDLL:
'       noDLL\*.bas
' opens:
'   frmBG
'   frmSystray

Option Explicit

Public bgImgName As String, fileManPath As String
Public showExit As Boolean, confirmExit As Boolean
Public lockButtons As Boolean, runDialog As Boolean
Public showImgNav As Boolean, isShell As Boolean
Public randTime As Integer
Public showSystray As Boolean, systrayLoaded As Boolean
Public startMenuStartup As Boolean


Sub Main()
    ' entry point (sorta)
    ' calls:
    '   readINI     (modINI)
    '   if noDLL:
    '       appLog              (noDLL\dllImageLister.bas)
    '       runStartup          (modAPI->noDLL\Startup.bas)
    '       setInitialValues    (noDLL\dllImageLister.bas)
    '   else:
    '       appLog      (modAPI->EEShell2.dll->EEShell.bas)
    '       runStartup  (modAPI->EEShell2.dll->Startup.bi)
    '       setPath     (modAPI->EEShell2.dll->EEShell.bas)
    ' loads:
    '   frmBG
    '   frmSystray

    If App.PrevInstance Then Exit Sub
    On Error GoTo ohCrapMain    ' any errors while loading will cause the load to stop

    setDefaults

#If noDLL Then
    setInitialValues
#Else
    setPath
#End If

    Load frmBG
    DoEvents
    readINI

    With frmBG
        .cmdFileMan.ToolTipText = "Run your chosen file manager (currently " & IIf(Len(fileManPath), fileManPath, _
                "Explorer") & ")"
        If Len(bgImgName) Then .imgBG.Visible = True
        .Show
        .Refresh
        .cmdExit.Enabled = True
    End With

    runStartup Command$, CLng(startMenuStartup)
    If showSystray Then Load frmSystray
    frmBG.Refresh
    Exit Sub

ohCrapMain:
    Dim X As String
    X = "Error " & CStr(Err.Number) & " in Main: " & Err.Description & " -- exiting."
    Err.Clear
    MsgBox X
#If noDLL Then
    ' in Win32 if the DLL is missing, then get some funky recursive error...
    appLog X
#End If
    Dim n As Form
    For Each n In Forms
        Unload n
    Next
End Sub


Public Sub fixSlash(ByRef Path As String)
    ' adds a trailing "\" if not already there
    ' args:
    '   path    do I really need to explain this?
    ' called by:
    '   checkList
    '   makeImgList
    '   randPic
    '   recurseDirs

    If Right$(Path, 1) <> "\" Then Path = Path & "\"
End Sub


Public Sub verifyImage(Optional ByRef what As String)
    ' verifies that bgImgName really exists
    ' optionally verifies that passed filename also exists
    ' if not, modifies them to work properly
    ' args:
    '   what    optional path to check -- must be string
    ' called by:

    ' This really isn't necessary, because:
    ' 1) I'm the only person who actually works on EEShell2
    ' 2) I don't use variants unless there's *NO OTHER CHOICE*
    '    - I have a strong dislike of variants, for a number of reasons
    ' 3) Every piece of code that calls this sub already passes a string anyway
    ' Actually... now that I think about it, this line probably breaks the code:
    ' If "what" isn't passed in, then its type certainly isn't going to be
    ' String, is it?
    'If vbString <> VarType(what) Then Exit Sub

    Dim tmpStr1 As String, tmpLng1 As Long

    If bgImgName <> "" Then
        tmpStr1 = Dir$(bgImgName)
        If Len(tmpStr1) Then
            tmpLng1 = GetAttr(bgImgName)
            If FILE_ATTRIBUTE_DIRECTORY = (tmpLng1 And FILE_ATTRIBUTE_DIRECTORY) Then
                'directory, modify
                fixSlash bgImgName
            End If
        Else
            'file not found
            bgImgName = ""
        End If
    End If

    If what <> "" Then
        tmpStr1 = Dir$(what)
        If Len(tmpStr1) Then
            tmpLng1 = GetAttr(what)
            If FILE_ATTRIBUTE_DIRECTORY = (tmpLng1 And FILE_ATTRIBUTE_DIRECTORY) Then
                'directory, modify
                fixSlash what
            End If
        Else
            'file not found
            what = ""
        End If
    End If
End Sub


Private Sub setDefaults()
    isShell = False
    lockButtons = False
    runDialog = True
    showExit = True
    showImgNav = True

    If WinVer < 4! Then
        fileManPath = "WinFile.exe"
    Else
        fileManPath = "Explorer.exe"
    End If  ' WinVer < 4
    showSystray = True
    startMenuStartup = True
End Sub
