Attribute VB_Name = "dllShutdown"
' the shutdown module for EEShell2
' requires:
'   dllMain.bas
'   dllWin32API.bas

' Found somewhere on the www (can't remember where) so not copyrighted by me
' (although I *did* port it from VB to PB -- and then back to VB (sigh)).

' This is only used in EEShell2-noDLL and EEShell2/16.

Option Explicit


Sub EnableShutDown()
    ' Set the shut down privilege for the current application
    ' calls:
    '   AdjustTokenPrivileges   (dllWin32API.bas->advapi32)
    '   GetCurrentProcess       (dllWin32API.bas->kernel32)
    '   LookupPrivilegeValue    (dllWin32API.bas->advapi32)
    '   OpenProcessToken        (dllWin32API.bas->advapi32)
    ' called by:
    '   quitWindows

    Dim hProc As Long, hToken As Long, mLUID As LUID
    Dim mPriv As TOKEN_PRIVILEGES, mNewPriv As TOKEN_PRIVILEGES

    hProc = GetCurrentProcess()
    OpenProcessToken hProc, TOKEN_ADJUST_PRIVILEGES + TOKEN_QUERY, hToken
    LookupPrivilegeValue "", "SeShutdownPrivilege", mLUID
    mPriv.PrivilegeCount = 1
    mPriv.Privileges(0).Attributes = SE_PRIVILEGE_ENABLED
    mPriv.Privileges(0).pLuid = mLUID

    ' enable shutdown privilege for the current application
    AdjustTokenPrivileges hToken, 0, mPriv, 4 + (12 * mPriv.PrivilegeCount), _
            mNewPriv, 4 + (12 * mNewPriv.PrivilegeCount)
End Sub


Function quitWindows(which As Long) As Long
    ' exit windows (duh)
    ' args:
    '   which   what kind of shutdown to do (values defined in modAPI as EWX_*)
    ' calls:
    '   appLog          (dllMain.bas)
    '   EnableShutDown
    '   ExitWindowsEx   (dllWin32API.bas->user32)
    '   IsWinNT         (dllMain.bas)
    '   FormatMessage   (dllWin32API.bas->kernel32)
    ' called by:
    '   frmBG.cmdLogoff_Click
    '   frmBG.cmdRestart_Click
    '   frmBG.cmdShutdown_Click

    Dim n As Long

#If dBug Then
    appLog "ExitWindowsEx code " & Str$(which)
#End If
    If IsWinNT Then EnableShutDown
    n = ExitWindowsEx(which, &HFFFF) '((which Or EWX_FORCE), &HFFFF)
    If n Then
        Dim X As String * 256
        n = 0
        FormatMessage FORMAT_MESSAGE_FROM_SYSTEM, n, Err.LastDllError, 0, X, 255, n
#If dBug Then
        appLog "ExitWindowsEx: " & X
#End If
        quitWindows = 0
    Else
        quitWindows = -1
    End If
End Function
