Attribute VB_Name = "dllAPI"
' API declaration for EEShell2.dll
' VB-ized version of Win32API.bi, trimmed down from PB/Win's Win32API.inc
' required by:
'   dllMain.bas
'   dllRun.bas
'   dllShell.bas
'   dllShutdown.bas
'   dllStartup.bas

' Copyright 2004-2010 Erik Siers
' Provided under terms of the GNU GPL; see the file COPYING.TXT for details.

' This is only used in EEShell2-noDLL.vbp.

' Information also found in modAPI.bas has been removed from here;
' this should prevent noDLL\* from compiling to an actual DLL, which is the way I want it.


#If Win32 Then
    Public Const ERROR_SUCCESS = 0
    Public Const SE_PRIVILEGE_ENABLED = 2
    Public Const TOKEN_QUERY = 8
    Public Const TOKEN_ADJUST_PRIVILEGES = &H20
    Public Const VER_PLATFORM_WIN32_NT = 2

    Public Const HKEY_CURRENT_USER = &H80000001
    Public Const HKEY_LOCAL_MACHINE = &H80000002
    Public Const REG_SZ = 1     ' Unicode nul terminated string
    Public Const KEY_QUERY_VALUE = 1
    Public Const KEY_SET_VALUE = 2
    Public Const KEY_CREATE_SUB_KEY = 4
    Public Const KEY_ENUMERATE_SUB_KEYS = 8
    Public Const KEY_NOTIFY = &H10
    Public Const KEY_CREATE_LINK = &H20
    Public Const SYNCHRONIZE = &H100000
    Public Const STANDARD_RIGHTS_ALL = &H1F0000
    Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or _
                 KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))

    Public Const ANYSIZE_ARRAY = 1


    Public Type LUID
        LowPart As Long
        HighPart As Long
    End Type

    Public Type LUID_AND_ATTRIBUTES
            pLuid As LUID
            Attributes As Long
    End Type

    Public Type OSVERSIONINFO
            dwOSVersionInfoSize As Long
            dwMajorVersion As Long
            dwMinorVersion As Long
            dwBuildNumber As Long
            dwPlatformId As Long
            szCSDVersion As String * 128      '  Maintenance string for PSS usage
    End Type

    Public Type TOKEN_PRIVILEGES
        PrivilegeCount As Long
        Privileges(ANYSIZE_ARRAY) As LUID_AND_ATTRIBUTES
    End Type


    ' advapi32
    Public Declare Function AdjustTokenPrivileges Lib "advapi32.dll" (ByVal TokenHandle As Long, _
            ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, _
            PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
    Public Declare Function LookupPrivilegeValue Lib "advapi32.dll" Alias "LookupPrivilegeValueA" ( _
            ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
    Public Declare Function OpenProcessToken Lib "advapi32.dll" (ByVal ProcessHandle As Long, _
            ByVal DesiredAccess As Long, TokenHandle As Long) As Long
    Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
    Public Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, _
            ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
    Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, _
            ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, _
            lpcbData As Long) As Long
    Public Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, _
            ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, _
            ByVal cbData As Long) As Long

    ' kernel32
    Public Declare Function GetCurrentProcess Lib "kernel32" () As Long
    Public Declare Function GetPrivateProfileString Lib "kernel32" Alias _
            "GetPrivateProfileStringA" (ByVal lpApplicationName As String, _
            ByVal lpKeyName As Any, ByVal lpDefault As String, _
            ByVal lpReturnedString As String, ByVal nSize As Long, _
            ByVal lpFileName As String) As Long
    Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As Any) As Long
    '-----this one added to make things work in VB-----------------
    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
    Public Declare Function WritePrivateProfileString Lib "kernel32" Alias _
            "WritePrivateProfileStringA" (ByVal lpApplicationName As String, _
            ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

    ' shell32
    Public Declare Function ShellExecute Lib "shell32" Alias "ShellExecuteA" (ByVal hWnd As Long, _
            ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, _
            ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
    Declare Function SHGetSpecialFolderPath Lib "shell32" Alias "SHGetSpecialFolderPathA" (ByVal hWndOwner As Long, _
            ByVal lpszPath As String, ByVal nFolder As Long, ByVal fCreate As Long) As Long

    ' user32
    Public Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long
#Else   ' Win16, but something... not quite right
    Public Declare Function GetCurrentTask Lib "kernel" () As Integer
    Public Declare Function GetPrivateProfileString Lib "kernel" (ByVal lpszSection As String, _
            ByVal lpszEntry As Any, ByVal lpszDefault As String, ByRef lpszReturnBuffer As String, _
            ByVal cbReturnBuffer As Integer, ByVal lpszFileName As String) As Integer
    Public Declare Function GetVersion Lib "kernel" () As Long
    '-----this one added to make things work in VB-----------------
    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
    Public Declare Function WritePrivateProfileString Lib "kernel32" Alias _
            "WritePrivateProfileStringA" (ByVal lpApplicationName As String, _
            ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long

    Public Declare Function ShellExecute Lib "shell" (ByVal hWnd As Long, ByVal lpOperation As String, _
            ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, _
            ByVal nShowCmd As Long) As Integer
#End If 'Win32
