Attribute VB_Name = "dllMain"
' main file for EEShell2.dll, translated back to VB
' requires:
'   dllWin32API.bas
' required by:
'   dllRun.bas
'   dllShell.bas
'   dllShutdown.bas
'   dllStartup.bas

' Copyright 2004-2010 Erik Siers
' Provided under terms of the GNU GPL; see the file COPYING.TXT for details.

' This is only used in EEShell2-noDLL and EEShell2/16.


Option Explicit

Const usePNG = 0 'also controls PCX - once it's working for sure in the main app, remove all references to this


Function WinVer() As Single
        ' returns the Windows version, i.e. 3.11
    Dim inf As Long
    Dim WinMaj As Byte, WinMin As Byte
    Dim retval As Single

    inf = GetVersion
    WinMaj = inf And &HFF
    WinMin = (inf \ &H100) And &HFF
    retval = CSng(WinMaj) + (CSng(WinMin) / 100)
    WinVer = retval
End Function


#If Win16 Then
    ' this function isn't used anywhere by anything...
    ' but I wrote it, so here it is...
    #If 0 Then
        Function DosVer() As Single
            ' returns the DOS version, i.e. 6.22
            Dim inf As Long
            Dim DosMaj As Byte, DosMin As Byte
            Dim retval As Single

            inf = GetVersion
            DosMaj = (inf \ &H1000000) And &HFF
            DosMin = (inf \ &H10000) And &HFF
            retval = CSng(DosMaj) + (CSng(DosMin) / 100)
            DosVer = retval
        End Function
    #End If ' 0
#Else
    Function IsWinNT() As Long
        ' Detect if the program is running under Windows NT
        ' found somewhere on the www
        ' calls:
        '   GetVersionEx    (dllWin32API.bas->kernel32)
        ' called by:
        '   getSystemShell  (dllShell.bas)
        '   setSystemShell  (dllShell.bas)
        '   quitWindows     (dllShutdown.bas)

        Dim myOS As OSVERSIONINFO

        myOS.dwOSVersionInfoSize = Len(myOS)
        GetVersionEx myOS
        IsWinNT = Not (myOS.dwPlatformId <> VER_PLATFORM_WIN32_NT)
    End Function
#End If ' Win16


Sub appLog(logEvent As String)
    ' logs anything sent its way
    ' args:
    '   logEvent    what to log
    ' called by:
    '   GetKeyValue         (dllShell.bas)
    '   quitWindows         (dllShutdown.bas)
    '   Run                 (dllRun.bas)  (if I can ever figure out error handling)
    '   runStartup          (dllStartup.bas)
    '   SetKeyValue         (dllShell.bas)
    '   SetSystemShellNT    (dllShell.bas)
    '   frmBG.cmdExit_Click
    '   frmBG.cmdLogoff_Click
    '   frmBG.cmdRestart_Click
    '   frmBG.cmdShutdown_Click
    '   frmBG.doImage
    '   frmBG.Form_Load
    '   frmBG.mnuPopupButtonDefaults_Click
    '   frmBG.resizeForm
    '   frmOpts.cmdOK_Click
    '   frmOpts.Form_Load
    '   modMain.Main

    On Error Resume Next
    Dim n As Long
    Static p As String

    n = FreeFile
    p = App.Path
    Open App.Path & "\EEShell2.log" For Append As n
        Print #n, Date$ & " " & Time$ & " - " & logEvent
    Close
End Sub


Sub GetDesktopInfo(ByRef loc_X As Long, ByRef loc_Y As Long, ByRef size_Width As Long, ByRef size_Height As Long, _
        ByRef client_Width As Long, ByRef client_Height As Long)
    ' gets desktop size info
    ' args:
    '   loc_X, loc_Y                top left corner of desktop
    '   size_Width, size_Height     size of desktop
    '   client_Width, clientHeight  size of client area
    ' called by:
    '   frmBG.resizeForm

    loc_X = 0
    loc_Y = 0
    size_Width = Screen.Width
    size_Height = Screen.Height
    client_Width = size_Width   ' need to throw in an API call to get these two;
    client_Height = size_Height ' the client area is *not* the same as the screen size
End Sub
