Attribute VB_Name = "dllRun"
' the run module for EEShell2
' requires:
'   dllMain.bas
'   dllWin32API.bas
' required by:
'   dllStartup.bas

' Copyright 2004-2010 Erik Siers
' Provided under terms of the GNU GPL; see the file COPYING.TXT for details.

' This is only used in EEShell2-noDLL and EEShell2/16.

Option Explicit

Function resEnv(pPath As String) As String
    ' resolves environment variables
    ' args:
    '   pPath   the string containing env.vars to resolve
    '           begins with env.var, need to find first %, chop, resolve
    ' calls:
    '   ExpandEnvironmentStrings    (dllWin32API.bas->kernel32)
    '   resEnv ***RECURSIVE***      (only if not win32)
    ' called by:
    '   Run

    Dim p As Integer, p2 As Integer, e As String, o As String

    p = InStr(pPath, "%")
    If p Then
        e = Left$(pPath, p - 1)
        p2 = InStr(p + 1, pPath, "%")
        If p2 Then
            o = Environ$(e) & Mid$(pPath, p + 1, p2 - p - 1) & resEnv(Mid$(pPath, p2 + 1))
        Else
            o = Environ$(e) & Mid$(pPath, p + 1)
        End If
    End If

    resEnv = o
End Function


Public Sub Run(runItem As String, cmdLine As String, defPath As String)
    ' launches runItem
    ' args:
    '   runItem     the item to launch
    '   cmdLine     args to runItem
    '   defPath     default path for runItem
    ' calls:
    '   appLog      (dllMain.bas)
    '   resEnv
    ' called by:
    '   runStartup  (dllStartup.bas)
    '   frmBG.cmdFileMan_Click
    '   frmBG.cmdRun_Click

    'to do: allow searching of %path%
    'right now, item must be the full path to whatever is being started
    'environment variables dealt with
    On Error GoTo ohCrapRun
    Dim sE As Long

    'resolve environment variables
    sE = InStr(runItem, "%")
    If sE Then runItem = Left$(runItem, sE - 1) & resEnv(Mid$(runItem, sE + 1))

    'check and set default path in case missing path breaks app
    '(known issue with Black Isle games and some other apps)
    If Len(defPath) < 1 Then
        sE = InStrRev(runItem, "\")
        If sE Then defPath = Left$(runItem, sE - 1)
    End If

    sE = ShellExecute(0, "", runItem, cmdLine, defPath, 5)
#If dBug Then
    If sE <= 32 Then appLog "ShellExecute: Error #" & Str$(sE)
#End If
    If sE = 2 Then MsgBox "File not found."
    Exit Sub

ohCrapRun:
    Dim X As String * 256
    sE = Err.Number
    Err.Clear
    If sE Then
        X = "Error " & Str$(sE) & " in Run: " & Error$(sE)
    Else
        sE = 0
        FormatMessage FORMAT_MESSAGE_FROM_SYSTEM, sE, Err.LastDllError, 0, X, 256, sE
    End If
    Dim x2 As String
    x2 = X
#If dBug Then
    appLog x2
#End If
End Sub
