Attribute VB_Name = "dllStartUp"
' the startup module for EEShell2
' requires:
'   dllMain.bas
'   dllRun.bas

' Copyright 2004-2010 Erik Siers
' Provided under terms of the GNU GPL; see the file COPYING.TXT for details.

' This is only used in EEShell2-noDLL and EEShell2/16.

Option Explicit

Public Sub runStartup(cmd As String, startup As Long)
    ' opens all .lnk and .pif files in %EEShell2%\Startup directory
    ' (skipped if -nostartup)
    ' args:
    '   cmd     command$ from VB
    ' calls:
    '   appLog  (dllMain.bas)
    '   Run     (dllRun.bas)
    ' called by:
    '   modMain.Main

    On Error GoTo ohCrapStartup
    Dim X As String
    X = LCase$(Trim$(cmd))
    If InStr(X, "-nostartup") > 0 Then Exit Sub
    If InStr(X, "/nostartup") > 0 Then Exit Sub

    Dim c As String, n As Long, m As Long, a1 As Long, a2 As Long, found As Long
    ReDim runlist(0) As String * MAX_PATH

    n = -1
    X = Dir$(App.Path & "\Startup", FILE_ATTRIBUTE_DIRECTORY)
    If Len(X) Then
        X = ""
        c = CurDir$
        ChDir App.Path & "\Startup"
#If dBug Then
        appLog "Executing startup"
#End If
        X = Dir$("*.lnk")
        If Len(X) Then
            found = 1
            Do
                If LCase$(Left$(X, 8)) <> "disabled" Then
                    n = n + 1
                    ReDim Preserve runlist(n)
                    For m = n - 1 To 0 Step -1
                        If X < runlist(m) Then
                            runlist(m + 1) = runlist(m)
                        Else
                            runlist(m + 1) = X
                            GoTo skipper1
                        End If
                    Next
                    runlist(0) = X
                End If
skipper1:
                X = Dir$
            Loop While Len(X)
        End If
        X = Dir$("*.pif")
        If Len(X) Then
            found = 1
            Do
                If LCase$(Left$(X, 8)) <> "disabled" Then
                    n = n + 1
                    ReDim Preserve runlist(n)
                    For m = n - 1 To 0 Step -1
                        If X < runlist(m) Then
                            runlist(m + 1) = runlist(m)
                        Else
                            runlist(m + 1) = X
                            GoTo skipper2
                        End If
                    Next
                    runlist(0) = X
                End If
skipper2:
                X = Dir$
            Loop While Len(X)
        End If
        For m = 0 To UBound(runlist)
            Run runlist(m), "", ""
#If Win32 Then
            Sleep 0
#Else
            DoEvents
#End If
        Next
        ChDir c
    End If

#If Win32 Then
    If startup Then
        Dim runStartMenu As String
        n = SHGetSpecialFolderPath(0, runStartMenu, CSIDL_STARTUP, 0)
        If Len(runStartMenu) Then   ' and if not, then wtf?
            X = CurDir$
            ChDir runStartMenu
            runStartMenu = Dir$("*.*")
            Do While runStartMenu <> ""
                If UCase$(Right$(runStartMenu, 4)) <> ".INI" Then
                    Run runStartMenu, "", ""
                    runStartMenu = Dir$
                End If
            Loop
        End If
    End If
#End If

    Exit Sub

ohCrapStartup:
    n = Err.Number
    Err.Clear
    X = "Error " & Str$(n) & " in runStartup: " & Error$(n)
    appLog X
End Sub
